# coding:utf-8
from IndexItem import IndexItem
from IndexComputerFile import IndexComputer
import json,redis,datetime,pymysql
class RiskComputer:
    IndexRes={}
    indexs=[]
    RCFactorsValue={}
    # batch_No=0
    def IndexsGet(self,indexs):
        self.indexs=indexs
    def FactorGet(self,factors):
        self.RCFactorsValue=factors
    def Compute(self):#计算所有指标
        for indexItem in self.indexs:
            factors=indexItem.Factors.split(":")
            flag=True
            indexItem.FactorsValue={}
            for factor in factors:
                if factor in self.RCFactorsValue:
                    indexItem.FactorsValue[factor]=self.RCFactorsValue[factor]
                else:
                    flag=False
                    break
            if flag:
                ic=IndexComputer()
                ret=ic.Compute(indexItem)
                self.IndexRes[indexItem.Name]=ret
            else:
                self.IndexRes[indexItem.Name]="0"
    def Ret2Json(self):#把指标结果转化为樊辉需要的Json
        #json写入数据库
        db = pymysql.connect(host='43.247.184.35',port=8899,user='write',password='write',db='fktaxctl',charset="utf8mb4")
        cursor = db.cursor()
        for key in self.IndexRes:
            sql = """INSERT INTO result_set(batchno,indexName,status) VALUES ('"""+str(self.batch_No)+"""', '"""+str(key)+"""','"""+str(self.IndexRes[key])+"""')"""
            try:
               cursor.execute(sql)
               # 提交到数据库执行
               db.commit()
            except:
               db.rollback()

        # 关闭数据库连接
        db.close()
        jsonStr=json.dumps(self.IndexRes,ensure_ascii=False, indent=4, separators=(',', ':'))
        #写入信息到Redis的队列中
        redisPool = redis.ConnectionPool(host='43.247.184.32', port=8967, password='Gongsibao2018',db=2)
        client = redis.Redis(connection_pool=redisPool)
        client.lpush('funcmq','{"key":'+str(datetime.datetime.now())+',"content":'+str(self.batch_No)+'}')
        return jsonStr