#!/usr/bin/env python
# -*- coding: utf-8 -*-
# @Time    : 2019/12/29 0029 下午 3:01
# @Author  : hj
# @File    : IndexGet.py
# @Software: PyCharm
import pymysql
from IndexItem import IndexItem
class IndexGet:
    conn = pymysql.connect(host='43.247.184.35',port=8899,user='write',password='write',db='fktaxctl',charset="utf8mb4")
    def Subscribe(self,span,type):
        print("查询条件",span,type)
        cursor = self.conn.cursor()
        list = []
        sql = "SELECT * from gongshi WHERE span = %s and type = %s;"
        try:
            # 执行SQL语句
            cursor.execute(sql,[span,type])
            # 获取所有记录列表
            results = cursor.fetchall()
            for row in results:
                indexItem=IndexItem()
                indexItem.Name = row[1]
                indexItem.IndexName = row[2]
                funs = str(row[3])
                if "max" not in funs and "min" not in funs:
                    funs=str(row[3]).replace("\n","").replace("；",";").replace(")]","))").replace("AND","and").replace("OR","or").replace("[(","((").split(";")
                else:
                    funs=str(row[3]).replace("\n","").replace("；",";").replace("AND","and").replace("OR","or").split(";")
                funsGrp=[]
                for fun in funs:
                    funsGrp.append(fun)
                indexItem.Funs=funsGrp
                indexItem.Span = row[5]
                indexItem.Factors=row[4]
                indexItem.Type = row[6]
                list.append(indexItem)
        except:
            print("Error: unable to fetch data")
            return ("Error: unable to fetch data")
        finally:
            cursor.close()
        return list
    def close(self):
        self.conn.close()